<template>
  <div>
    <div class="game-show">
      <div class="image game-show__interface">
        <b-icon class="clickable"
                @click.native="saveScore"
                icon="play-circle"
                size="is-large" />
      </div>

      <div class="card">
        <header class="card-header">
          <p class="card-header-title">
            {{ game.name }}
          </p>
        </header>
        <div class="card-content">
          <div class="content">
            <b-tabs class="block"
                    expanded
                    v-model="activeTab"
                    size="is-small" >
              <!-- INFO       -->
              <b-tab-item v-html="info"
                          :label="$t('games.show.infos')"
                          icon="question-circle" />
              <!-- RULES -->
              <b-tab-item :label="$t('games.show.rules')"
                          icon="align-center">
                regles
              </b-tab-item>
              <!-- SCORES -->
              <b-tab-item :label="$t('games.show.score')"
                          icon="trophy">
                <p>
                  <span class="has-text-weight-bold
                               has-text-green">
                    {{ $t('games.show.scores.highest') }}</span>
                    {{ $n(scores.best) }}
                </p>
                <div class="user-scores">
                  <span>
                    <span class="has-text-weight-bold
                                 has-text-green">
                    {{ $t('games.show.scores.personal') }}</span>
                    {{ $n(scores.userBest) }}
                  </span>
                    <span>
                    <span class="has-text-weight-bold
                                 has-text-green">
                    {{ $t('games.show.scores.period') }}</span>
                    {{ $n(scores.userPeriodBest) }}
                  </span>
                </div>
                <ul class="game-show__steps">
                  <li v-for="(step, i) in game.steps"
                      :key="step.name">
                    <step-icon :name="step.name" />
                    <span
                      :class="{ 'is-striked': scores.userPeriodBest >= step.value }"
                    >
                      {{ $n(step.value) }}
                    </span>
                    <template v-if="i === 3">
                      <feather />
                      {{ $n(scores.feather) }}
                    </template>
                  </li>
                </ul>
              </b-tab-item>
            </b-tabs>
          </div>
          <!-- FOOTER -->
          <footer class="card-footer">
            <p class="card-footer-item">
              <game-pin :id="game.id"
                        :pinned.sync="game.pinned" />
            </p>
            <p class="card-footer-item">
              <router-link :to="{ name: 'GamesRanking',
                                  params: { id: game.id,
                                            level: userTrophy } }">
                <b-icon icon="trophy" type="is-primary" />
                {{ $t('games.show.ranking') }}
              </router-link>
            </p>
            <p class="card-footer-item">
              <router-link :to="{ name: 'Pantheon',
                                  params: { id: game.id } }">
                <b-icon icon="award" type="is-primary" />Panthéon
              </router-link>
            </p>
            <p class="card-footer-item">
              <b-switch v-model="HD">
                HD
              </b-switch>
            </p>
          </footer>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import { random, pick } from 'lodash';

import { Game } from '@/types/games';
import { SET_LOADING } from '@/store';
import GameMixin from '@/mixins/game.vue';
import INFOS from '@/components/games/infos';
import GamePin from '@/components/games/GamePin.vue';
import StepIcon from '@/components/StepIcon.vue';
import Feather from '@/components/Feather.vue';
import { Trophy } from '@/types/scores';

@Component({
  components: { GamePin, StepIcon, Feather },
})
export default class GamesShow extends GameMixin {
  activeTab: number = 2;
  game: Game = {
    id: 0,
    name: null,
    mode: 'action',
    pinned: false,
    steps: [],
  };
  scores: {
    best: number;
    userBest: number;
    userPeriodBest: number;
    feather: number;
  } = {
    best: 0,
    userBest: 0,
    userPeriodBest: 0,
    feather: 0,
  };
  userTrophy: Trophy = Trophy.NEWBIE;
  HD: boolean = true;

  async mounted() {
    const { data } = await this.$http.get(
      `games/show/${this.$route.params.id}`
    );
    this.game = pick(data, Object.keys(this.game));
    this.scores = pick(data, Object.keys(this.scores));
    this.userTrophy = data.level;
  }

  async saveScore() {
    const score: number = random(0, 1_500_000);
    try {
      await this.$http.post('scores/add', {
        game_id: this.game.id,
        score,
      });
      this.$buefy.toast.open({
        message: `${score} !`,
        type: 'is-success'
      })
    } catch(e) {
      this.$buefy.toast.open({
        message: this.$t('games.show.scoreError') as string,
        type: 'is-warning'
      })
    }
  }

  get info(): string {
    return INFOS[this.game.name];
  }
}
</script>

<style lang="scss" scoped>
.game-show {
  display: flex;
  flex-wrap: wrap;
  justify-content: center;
  padding: 1rem 0;
  &__interface {
    border: $k-border;
    background-color: lightgray;
    min-width: 335px;
    min-height: 360px;
    .icon {
      font-size: 2em;
      margin-top: calc(50% - 25px);
    }
  }
  &__steps {
    li {
      list-style-type: none;
    }
  }
  > * {
    margin: 1rem;
  }
  > .card {
    width: 600px;
    height: 360px;
    .card-content {
      padding: 0;
    }
    .content {
      margin-bottom: 0 !important;
    }
  }
  .tab-content {
    padding-bottom: 0.1rem;
  }
  .tab-item {
    height: 190px;
    overflow: auto;
  }
  .card-header-title {
    justify-content: center;
  }
  .user-scores > span {
    margin: 0 1rem;
  }
}
</style>
